#include <utility.h>
#include "niswitch.h"

int main (void)
{
   ViSession instr;              /* Communication Channel */
   ViStatus status;           /* For checking errors */
   ViInt32  i;
   
   
   /* Begin by opening a communication channel to the instrument */
   status = niSwitch_init("SCXI1::4::INDEP", VI_TRUE, VI_TRUE, &instr);
   if (status < VI_SUCCESS) {
      /* Error Initializing Interface...exiting */
      return -1;
   }
   
   /* Close switch #1 */
   status = niSwitch_SingleSwitchControl(instr, "ch1", 
                                         NISWITCH_VAL_SWITCH_CLOSE );
   if (status < VI_SUCCESS) {
      /* Error Initializing Interface...exiting */
   return -1;
   }
   
   /* Close switch #7 */
   status = niSwitch_SingleSwitchControl(instr, "ch7", 
                                         NISWITCH_VAL_SWITCH_CLOSE );
   if (status < VI_SUCCESS) {
      /* Error Initializing Interface...exiting */
   return -1;
   }

   /* Close switch BC01 */
   status = niSwitch_SingleSwitchControl(instr, "bc01", 
                                         NISWITCH_VAL_SWITCH_CLOSE );
   if (status < VI_SUCCESS) {
      /* Error Initializing Interface...exiting */
   return -1;
   }
   
   /* Close switch #10 */
   status = niSwitch_SingleSwitchControl(instr, "ch10", 
                                         NISWITCH_VAL_SWITCH_CLOSE );
   if (status < VI_SUCCESS) {
      /* Error Initializing Interface...exiting */
   return -1;
   }
   
   /* Close communication channel */
   status = niSwitch_close(instr);
   return 0;
}
